/*
			Copyright (c) 1994 by
			Advanced Visual Systems Inc.
			All Rights Reserved
	
	This software comprises unpublished confidential information of
	Advanced Visual Systems Inc. and may not be used, copied or made
	available to anyone, except in accordance with the license
	under which it is furnished.
	
	This file is under Perforce control
	$Id: //depot/express/fcs992/modules/add_cmd.c#1 $
*/
#include <avs/util.h>
#include <avs/err.h>
#include <avs/db.h>
#include <avs/fld.h>
#include <avs/arr.h>

int add_cmd(elem_id)
    OMobj_id elem_id;
{

	OMobj_id parent;
	OMobj_id loc_cmd, tmp, val;
	int i, cmd_size;

	loc_cmd = OMfind_subobj(elem_id,OMstr_to_name("cmd"),OM_OBJ_RW);
	parent = OMfind_subobj(elem_id,OMstr_to_name("parent"),OM_OBJ_RW);
	if (OMget_obj_val(parent,&parent) != 1) return(0);
	OMget_obj_parent(parent,&tmp);
	tmp = OMfind_subobj(tmp,OMstr_to_name("Modules"),OM_OBJ_RW);
	if (OMis_null_obj(tmp)) return(1);
	tmp = OMfind_subobj(tmp,OMstr_to_name("cmdList"),OM_OBJ_RW);
	if (OMis_null_obj(tmp)) return(1);

	/* First see if the command is already there... if so, bag it */
	if (OMget_array_size(tmp, &cmd_size) != 1) {
	   OMadd_array_val(tmp,loc_cmd);
	   return(1);
	}
	else {
	   for (i = 0; i < cmd_size; i++) {
	      if (OMget_array_val(tmp,i,&val,OM_OBJ_RD) == 1 &&
		  OMget_obj_val(val,&val) == 1 &&
		  OMequal_objs(val,loc_cmd)) return(1);
	   }
	}
	OMadd_array_val(tmp,loc_cmd);
	return(1);
}
